<?php
/*
	# For input field
	$data[ LABEL ][ value ] = YOUR VALUE
				  [ type ] = keep empty or 'input'
				  
	# For selector Box		
	$data[ LABEL ][ value ]	= YOUR VALUE
	$data[ LABEL ][ options ][0] = YOUR VALUE
							 [1] = YOUR VALUE
				  [ type ] = 'select'
				  
	# For hidden field
	$data[ LABEL ][ value ] = YOUR VALUE
				  [ type ] = 'hidden'
	
	
*/
class FormGenerator{
	var $formclass;
	var $editable;
	var $typemerging; /// Default false . when set to true the names and types of a field will be merged in the name with a # tag.
	var $types;
	
	function __construct(){
		$this->types = array(
			"input"
			,"password"
			,"select"
			,"hidden"
			,"radio"
			,"checkbox"
			,"textarea"		
		);
		$this->editable = false;
		$this->typemerging = false;
	}

	function CreateForm($data, $class = 'custom-form', $method = 'POST', $target = ''){
		$this->formclass = $class;
		echo "<div class='{$class}'><form method='{$method}' action='{$target}'>";
		echo "<table class='custom-table'>";
		foreach($data as $k => $v){
			echo "<tr>";
				$this->CreateField($k, $v);
			echo "</tr>";
		}
		if($this->editable == true){
			echo "<tr>";
				echo "<td></td><td><img src='images/icons/32x32/window-new.png' style='width:16px; cursor:pointer;' title='Add New Element' class='add-field'</td>";
			echo "</tr>";
		}
		echo "</table></form></div>";
	}
	function CreateField($label, $values){
		if($this->typemerging == true){
			$this->fieldName = $label ."#". $values['type'];
		} else {
			$this->fieldName = $label;
		}
	
		if(empty($values['type']) || $values['type'] == 'input'){
			$this->InputField($label,$values['value']);
		} else if($values['type'] == 'select') {
			$this->SelectBox($label,$values['options'],$values['value']);
		} else if($values['type'] == 'hidden') {
			$this->HiddenField($label,$values['value']);
		} else if($values['type'] == 'radio') {
			$this->RadioField($label,$values['value']);
		} else if($values['type'] == 'checkbox') {
			$this->CheckBoxField($label,$values['value']);
		} else if($values['type'] == 'password') {
			$this->PasswordField($label,$values['value']);
		} else if($values['type'] == 'textarea') {
			$this->TextField($label,$values['value']);
		} else if($values['type'] == 'button') {
			$this->Button($label,$values['value']);
		} else if($values['type'] == 'submit') {
			$this->SubmitButton($label,$values['value']);
		}
	}	
	
	function TextField($label, $value){
		$m = (!$this->editable) ? "" : "<img title='Remove this Element' class='remove-field' src='images/icons/32x32/edit-delete-2.png' style='width:16px;' />";
		echo "<td><label for='custom-form-{$label}'>{$label}</label></td>";
		echo "<td><textarea id='{$this->formclass}-{$label}' name='{$this->fieldName}'>{$value}</textarea></td>";	
		echo "<td>$m</td>";
	}
	
	function SelectBox($label, $fields, $selected){
		$m = (!$this->editable) ? "" : "<img title='Remove this Element' rel='{$this->formclass}-{$label}-hidden' class='remove-field' src='images/icons/32x32/edit-delete-2.png' style='width:16px;' />";
		echo "<td><label for='{$this->formclass}-{$label}'>{$label}</label></td>";
		echo "<td>";
			echo "<select id='{$this->formclass}-{$label}' name='{$this->fieldName}'>";
			foreach($fields as $k => $v){
				$sel ='';
				if($v == $selected){
					$sel = "selected='selected'";
				} 
				echo "<option value='{$v}' $sel>{$v}</option>";
			}
			echo "</select>";
		echo "</td>";
		echo "<td>$m</td>";
		echo "<td><input type='hidden' value='". implode(",",$fields) ."' name='{$this->fieldName}#options' /></td>";
	}	
	
	function HiddenField($label,$value){
		echo "<td></td><td><input type='hidden' id='{$this->formclass}-{$label}' name='{$this->fieldName}' value='{$value}' /></td>";
	}
	
	function InputField($label,$value){
		$m = (!$this->editable) ? "" : "<img title='Remove this Element' class='remove-field' src='images/icons/32x32/edit-delete-2.png' style='width:16px;' />";
		echo "<td><label for='custom-form-{$label}'>{$label}</label></td>";
		echo "<td><input type='text' id='{$this->formclass}-{$label}' name='{$this->fieldName}' value='{$value}' /></td>";
		echo "<td>$m</td>";
	}
	
	function PasswordField($label,$value){
		$m = (!$this->editable) ? "" : "<img title='Remove this Element' class='remove-field' src='images/icons/32x32/edit-delete-2.png' style='width:16px;' />";
		echo "<td><label for='custom-form-{$label}'>{$label}</label></td>";
		echo "<td><input type='password' id='{$this->formclass}-{$label}' name='{$this->fieldName}' value='{$value}' /></td>";
		echo "<td>$m</td>";
	}
	
	function RadioField($label,$value){
		$m = (!$this->editable) ? "" : "<img title='Remove this Element' class='remove-field' src='images/icons/32x32/edit-delete-2.png' style='width:16px;' />";
		echo "<td><label for='custom-form-{$label}'>{$label}</label></td>";
		echo "<td><input type='radio' id='{$this->formclass}-{$label}' name='{$this->fieldName}' value='{$value}' />{$value}</td>";
		echo "<td>$m</td>";
	}
	
	function CheckBoxField($label,$value){
		$m = (!$this->editable) ? "" : "<img title='Remove this Element' class='remove-field' src='images/icons/32x32/edit-delete-2.png' style='width:16px;' />";
		echo "<td><label for='custom-form-{$label}'>{$label}</label></td>";
		echo "<td><input type='checkbox' id='{$this->formclass}-{$label}' name='{$this->fieldName}' value='{$value}' />{$value}</td>";
		echo "<td>$m</td>";
	}
	
	function Button($label,$value){
		echo "<td></td><td><input type='button' id='{$this->formclass}-{$label}' name='{$this->fieldName}' value='{$value}' /></td>";
	}
	
	function SubmitButton($label,$value){
		echo "<td></td><td><input type='submit' id='{$this->formclass}-{$label}' name='{$this->fieldName}' value='{$value}' /></td>";
	}
	
	function JqueryScript(){
		?><script type='text/javascript'>
		var typemerging = '<?php echo $this->typemerging; ?>';
		
		
		function field_prompter() {
			var new_label = prompt("What is the label of your new field?", "");
			if(new_label == "") {
				return false;
			}
			
			var new_type = prompt("What is the type of your new field?\n(<?php echo implode(",", $this->types); ?>)", "");
			
			
			var name = new_label;
			if(typemerging == 1){
				name = new_label+"#"+new_type;
			}
			
			if(new_type == 'select'){
				var new_options = prompt("What do you want your options to be?\n (separate options with ',' example: red,blue,etc..");
				var options = new_options.split(",");
				var insertfield = "<tr><td><label>"+new_label+"</label></td><td><select name='"+name+"'>";
				for(i=0; i< options.length; i++) {
					insertfield = insertfield + "<option value='"+options[i]+"'>"+options[i]+"</option>";
				}
				insertfield =  insertfield + "</select></td></tr>";
				insertfield =  insertfield + "<tr><td></td><td><input type='hidden' value='"+new_options+"' name='"+name+"#options' /></td></tr>";
				
				
				$(".custom-table").prepend(insertfield);
			}		
			
			
			
			if(new_type == 'input'){
				
				$(".custom-table").prepend("<tr><td><label>"+new_label+"</label></td><td><input name='"+name+"' type='text' /></td></tr>");
			} else if(new_type == 'radio') {
				$(".custom-table").prepend("<tr><td><label>"+new_label+"</label></td><td><input name='"+name+"' type='radio' /></td></tr>");		
			} else if(new_type == 'password') {
				$(".custom-table").prepend("<tr><td><label>"+new_label+"</label></td><td><input name='"+name+"' type='password' /></td></tr>");		
			}else if(new_type == 'checkbox') {
				$(".custom-table").prepend("<tr><td><label>"+new_label+"</label></td><td><input name='"+name+"' type='checkbox' /></td></tr>");		
			}else if(new_type == 'hidden') {
				$(".custom-table").prepend("<tr><td><label>"+new_label+"</label></td><td><input name='"+name+"' type='hidden' /></td></tr>");		
			}else if(new_type == 'textarea') {
				$(".custom-table").prepend("<tr><td><label>"+new_label+"</label></td><td><textarea  name='"+name+"'></textarea></td></tr>");		
			}else {
				return false;
			}	
			
		}
		$(document).ready( function() {		
			$(".remove-field").live("click", function(){
				var result = confirm("Are you sure you want to remove this field?");
				if(result){
					$(this).closest('tr').remove();
				}
			});	
			
			$(".add-field").live( "click", function(){	
				field_prompter();
			});			
		});			
		</script><?php
	}
}
?>